#!/usr/bin/perl

# Apache Guardian, Version 1.0
#	Copyright 1997 by Fluid Dynamics <xav.com>
#	You are free to use the script, but please ask before you 
#	distribute it.
#
# For latest version and help files, visit:
#	http://www.xav.com/scripts/guardian
# __________________________________________________________________


# Ihre email-Adresse:

	$email = 'sie@ihre-domain.de';

# Sollen Benachrichtigungen per email geschickt werden? (0 / 1)

	$send = 0;

# Die URL Ihrer Homepage:

	$main_page = 'http://www.ihre-site.de/index.htm';

# Die URL zu Ihrer Suchseite, falls eine existiert.  Ansonsten die folgende
# Zeile einfach loeschen bzw. kommentieren:

	$search_page = 'http://www.ihre-site.de/suche/index.htm';

# Der Pfad zum sendmail-Programm auf Ihrem Server (falls er vom Standardwert abweicht:

	$mailprog = '/usr/lib/sendmail';

# Umleitungen fuer Sachen, die inzwischen eine eigene Domain haben

	%redirections = (	"redir1",	"http://www.new-domain1.com/",
				"redir2",	"http://www.new-domain2.com/"	);

# Es ist kein weiteres Editieren notwendig, aber nur immer zu ...
# 
# __________________________________________________________________

# Einige Umgebungsvariable:
$root = $ENV{'DOCUMENT_ROOT'};
$host = $ENV{'HTTP_HOST'};
$refr = $ENV{'REDIRECT_URL'};

# Bezeichnung des Fehlers:
if ($ENV{'QUERY_STRING'} eq '401')
{
	$code = "Ungltige Anforderung";
}
elsif ($ENV{'QUERY_STRING'} eq '401')
{
	$code = "Verweigerter Zugriff";
}
elsif ($ENV{'QUERY_STRING'} eq '403')
{
	$code = "Fehlende Berechtigung";
}
elsif ($ENV{'QUERY_STRING'} eq '404')
{
	$code = "Unauffindbare Datei";
}
elsif ($ENV{'QUERY_STRING'} eq '405')
{
	$code = "Ressource nicht zugelassen";
}
elsif ($ENV{'QUERY_STRING'} eq '406')
{
	$code = "Nicht annehmbar";
}
elsif ($ENV{'QUERY_STRING'} eq '500')
{
	$code = "Scriptfehler";
}
else
{
	$code = "Undefinierter Grund";
}


# Versuchte Umleitung auf htm(l), wenn der andere Fall nicht existiert.
if($ENV{'QUERY_STRING'} eq '404')
{
	&html_subst;
}

# Umleitung auf umgezogene Inhalte
if($ENV{'QUERY_STRING'} eq '404')
{
	foreach $key (keys %redirections)
	{
		if($ENV{'SCRIPT_URI'} =~ /$key/)
		{
			&redirect($redirections{$key});		
		}
	}	
}

if($send)
{
	# Als naechstes ein email an den Webmaster:
	open(MAIL,"|$mailprog -t");
	print MAIL "To: $email\n";
	print MAIL "From: guardian\@xav.com (Apache Guardian)\n";
	print MAIL "Subject: Guardian-Report [$code]\n";
	print MAIL "X-Priority: 1 (Highest)\n\n";
	print MAIL "Versuchten Zugriff aufgezeichnet auf $ENV{'REDIRECT_URL'}\n";
	print MAIL "durch $ENV{'REMOTE_HOST'}.\n\n";
	if ($ENV{'HTTP_REFERER'})
	{
		@terms = split(/\//,$ENV{'HTTP_REFERER'});
		print MAIL "Besucher surfte herein von $ENV{'HTTP_REFERER'}. ";
		print MAIL "Bitte ggf. den Adminstrator folgender Site benachrichtigen: $terms[0]//$terms[2].\n\n";
	}
	else
	{
		print MAIL "In Zusammenhang mit diesem Besuch wurde keine verweisende URL aufgezeichnet.\n\n";
	}
	print MAIL "Hier die Einzelheiten:\n\n";
	foreach $key (sort keys %ENV)
	{
		print MAIL "$key: $ENV{$key}\n";
	}
	close(MAIL);
}


# Dann eine Erklrung fr den Besucher:
print "Content-type: text/html\n\n";
print <<EOM;
<HTML>
<HEAD>
<TITLE>Apache Guardian: $code</TITLE>
</HEAD>
<BODY BACKGROUND="http://www.gb-direkt.de/images/sumtextb.jpg" bgcolor="#FFFFFF" text="#808080" link="#3333CC" vlink="#666699" alink="#990099">
<font face="verdana, arial, helvetica">
<H2><font color="#003366">$code (Server-Fehler -  $ENV{'QUERY_STRING'})</font color></H2>
<BLOCKQUOTE><B>
EOM

if ($ENV{'QUERY_STRING'} eq '400')
{
	&explain_400;
}
elsif ($ENV{'QUERY_STRING'} eq '401')
{
	&explain_401;
}
if ($ENV{'QUERY_STRING'} eq '403')
{
	&explain_403;
}
elsif ($ENV{'QUERY_STRING'} eq '404')
{
	&explain_404;
}
elsif ($ENV{'QUERY_STRING'} eq '405')
{
	&explain_405;
}
elsif ($ENV{'QUERY_STRING'} eq '406')
{
	&explain_406;
}
elsif ($ENV{'QUERY_STRING'} eq '500')
{
	&explain_500;
}
else
{
	&default;
}
print "</B></BLOCKQUOTE>\n</BODY>\n</HTML>\n";

exit;


########################################
# Subroutinen (Erklrungen)
########################################

sub explain_400
{
	print <<EOM;
Die Seitenanforderung ist ungltig. Es sollte etwa der Art <a href="$main_page">$main_page</a> sein.<br>
Klicken Sie bitte auf Zurck in Ihrem Browser oder geben Sie eine gltige URL ein.
EOM
}


sub explain_401
{
	print <<EOM;
Das angeforderte Dokument ist kennwortgeschtzt. Falls Sie Ihr Kennwort vergessen 
haben oder aus anderen dringenden Grnden auf die geschtzten Informationen
zugreifen mssen, nehmen Sie bitte Kontakt zum <A HREF="mailto:$email">Webmaster</A> auf.<P>
Ansonsten klicken Sie bitte auf Zurck in Ihrem Browser.
EOM
}


sub explain_403
{
	print <<EOM;
Sie haben nicht die erforderliche Berechtigung, diese Seite anzuzeigen, oder der Zugriff wurde
vom ISP unmglich gemacht. Falls Sie aus dringenden Grnden auf die Informationen
zugreifen mssen, nehmen Sie bitte Kontakt zum <A HREF="mailto:$email">Webmaster</A> auf.<P>
Ansonsten klicken Sie bitte auf Zurck in Ihrem Browser.
EOM
}


sub explain_404
{
	print <<EOM;
Das Dokument, nach dem Sie suchen, ist entweder nicht mehr gltig oder befindet sich an anderer Stelle.<br>
Um bestimmte Dokumente zu finden, knnen Sie entweder auf unserer <A HREF="$main_page">Homepage</A> 
beginnen oder uns ein kurzes <A HREF="mailto:$email">email</A> schicken.
EOM
if ($search_page)
	{
	print "\n<P>Sie knnen auch mit unseren Site-internen <A HREF=\"$search_page\">Suchmechanismen</A>\n";
	print "nach dem bentigten Dokument Ausschau halten.\n";
	}
}


sub explain_405
{
	print <<EOM;
Die gewnschte Seite kann nicht angezeigt werden, da die Adresse ungltig ist.<br>
Um bestimmte Dokumente zu finden, knnen Sie entweder auf unserer <A HREF="$main_page">Homepage</A> 
beginnen oder uns ein kurzes <A HREF="mailto:$email">email</A> schicken.
EOM
if ($search_page)
	{
	print "\n<P>Sie knnen auch mit unseren Site-internen <A HREF=\"$search_page\">Suchmechanismen</A>\n";
	print "nach dem bentigten Dokument Ausschau halten.\n";
	}
}


sub explain_406
{
	print <<EOM;
Die gewnschte Ressource kann im Browser nicht angezeigt werden.<br>
Um bestimmte Dokumente zu finden, knnen Sie entweder auf unserer <A HREF="$main_page">Homepage</A> 
beginnen oder uns ein kurzes <A HREF="mailto:$email">email</A> schicken.
EOM
if ($search_page)
	{
	print "\n<P>Sie knnen auch mit unseren Site-internen <A HREF=\"$search_page\">Suchmechanismen</A>\n";
	print "nach dem bentigten Dokument Ausschau halten.\n";
	}
}


sub explain_500
{
	print <<EOM;
Das Script, auf das Sie zugreifen mchten, hat einen fatalen Fehler produziert. Falls Sie 
vor kurzem den Code gendert haben, knnen Sie den Fehler mglicherweise mittels
<TT><font color=\"\#0000FF\">perl -w $ENV{'REDIRECT_SCRIPT_FILENAME'}</font></TT> ausfindig machen.<p>
Falls Sie ein Besucher sind, versuchen Sie es zu einem spteren Zeitpunkt bitte 
noch einmal. Der Webmaster ist bereits ber den Fehler informiert worden. Es knnte hilfreich 
sein, wenn Sie uns kurze Informationen ber Ihre Formulareingabe 
<A HREF="mailto:$email">schicken</A> knnten.
EOM
}


sub default
{
	print <<EOM;
Es gab einen nicht nher definierten Fehler beim Zugriff auf die von Ihnen verlangte Datei.
Sie knnen es erneut von unserer <A HREF="$main_page">Homepage</A> aus versuchen
oder mit dem <A HREF="mailto:$email">Webmaster</A> Kontakt aufnehmen, um ihm genau 
zu schildern, auf welche Weise dieser Fehler aufgetreten ist, so da er beseitigt werden kann.
EOM
}


# Ersetzung *.htm<=>*.html 
sub html_subst
{
	local($target) = $refr;
	local($locale, $redurl);
	$target =~ s/^\///;
	if ($target =~ /\.html$/)
	{
		$target =~ s/\.html$//;
		$locale = "$root" . "$target" . "\.htm";
		if(-e $locale && -f $locale)
		{
			$redurl = "http\://$host" . "/" . "$target" . "\.htm";
			&redirect($redurl);
		}
	}
	elsif ($target =~ /\.htm$/)
	{
		$target =~ s/\.htm$//;
		$locale = "$root" . "$target" . "\.html";
		if(-e $locale && -f $locale)
		{
			$redurl = "http\://$host" . "/" . "$target" . "\.htm";
			&redirect($redurl);
		}
	}
}

# Umleitung
sub redirect
{
	local($url)=@_;
	print "Status: 302 Found\n";
	print "Location: $url\n";
	print "URI: <$url>\n";
	print "Content-type: text/html\n\n";
	exit(1);
} 
